"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.action = exports.service = void 0;
require("reflect-metadata");
const moleculer_service_decorators_1 = require("@anthrax63/moleculer-service-decorators");
const consts_1 = require("./consts");
const parameters_1 = require("@anthrax63/moleculer-service-decorators/dist/utils/parameters");
function service(options = {}) {
    const svc = (0, moleculer_service_decorators_1.service)(options);
    return function (constructor) {
        const name = options.name || constructor.name;
        Reflect.defineMetadata(consts_1.METADATA_KEY_ACTIONS, Reflect.getMetadata(`${moleculer_service_decorators_1.META_PREFIX}actions`, constructor.prototype), constructor.prototype);
        Reflect.defineMetadata(consts_1.METADATA_KEY_EVENTS, Reflect.getMetadata(`${moleculer_service_decorators_1.META_PREFIX}events`, constructor.prototype), constructor.prototype);
        Reflect.defineMetadata(consts_1.METADATA_KEY_NAME, name, constructor.prototype);
        return svc(constructor);
    };
}
exports.service = service;
function action(options) {
    const act = (0, moleculer_service_decorators_1.action)(options);
    return (target, propertyKey, descriptor) => {
        const func = descriptor.value;
        if (func &&
            typeof func === 'function' &&
            Reflect.getMetadataKeys(target).indexOf(`${moleculer_service_decorators_1.META_PREFIX}${propertyKey.toString()}Params`) !== -1) {
            const paramNames = (0, parameters_1.getParamNames)(func);
            const keyName = propertyKey.toString();
            Reflect.defineMetadata(`${consts_1.METADATA_KEY_ACTIONS}:${keyName}:params`, paramNames, target);
        }
        return act(target, propertyKey, descriptor);
    };
}
exports.action = action;
__exportStar(require("@anthrax63/moleculer-service-decorators/dist/constants"), exports);
__exportStar(require("@anthrax63/moleculer-service-decorators/dist/event"), exports);
__exportStar(require("@anthrax63/moleculer-service-decorators/dist/param"), exports);
//# sourceMappingURL=decorators.js.map