import 'reflect-metadata';
import moleculer from 'moleculer';
declare type ServiceOptionsToExclude = 'parseServiceSchema' | 'name' | 'fullName' | 'version?' | 'settings' | 'metadata' | 'dependencies' | 'schema' | 'originalSchema' | 'broker' | 'logger' | 'actions' | 'Promise' | '_init' | '_start' | '_stop' | 'waitForServices' | 'version';
declare type RemoveIndex<T> = {
    [K in keyof T as string extends K ? never : number extends K ? never : K]: T[K];
};
declare type ServiceProxyActions<T> = Pick<{
    [P in keyof T]: T[P] extends (a: moleculer.Context<infer M>) => Promise<infer R> ? (params: M) => Promise<R> : T[P] extends (a: moleculer.Context<infer M>) => infer R ? (params: M) => Promise<R> : T[P] extends (...a: infer M) => Promise<infer R> ? (...a: M) => Promise<R> : T[P] extends (...a: infer M) => infer R ? (...a: M) => Promise<R> : never;
}, keyof Omit<RemoveIndex<T>, ServiceOptionsToExclude>>;
export declare type ServiceProxy<T> = ServiceProxyActions<T>;
export interface ServiceBrokerLike {
    call<T, P>(actionName: string, params: P): Promise<T>;
    emit<D>(eventName: string, data: D): Promise<void>;
}
export declare class ServiceProxyFactory {
    private readonly broker;
    constructor(broker: ServiceBrokerLike);
    create<T extends object>(t: new (...args: never[]) => T): ServiceProxy<T>;
}
export {};
